;;;;;;;;;;;;;;;;;;;;;;;;;;;;;<--OGI-->;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                        ;;
;;             Center for Spoken Language Understanding                   ;;
;;        Oregon Graduate Institute of Science & Technology               ;;
;;                         Portland, OR USA                               ;;
;;                        Copyright (c) 1999                              ;;
;;                                                                        ;;
;;      This module is not part of the CSTR/University of Edinburgh       ;;
;;               release of the Festival TTS system.                      ;;
;;                                                                        ;;
;;  In addition to any conditions disclaimers below, please see the file  ;;
;;  "license_ogi_tts.txt" distributed with this software for information  ;;
;;  on usage and redistribution, and for a DISCLAIMER OF ALL WARRANTIES.  ;;
;;                                                                        ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;<--OGI-->;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(set! male22k_pmark_params  
 (list
;  '(infile_list (directory-entries "."))

  '(run_quietly 0) 
  '(dump_intermediate_files 1)

  '(infile_list ("mwm2_1" "mwm2_10" "mwm2_100" "mwm2_1000" "mwm2_210" "mwm2_2100"))

  '(lx_path "./")
  '(sp_path "./")
  '(lx_ext  ".lar")
  '(sp_ext  ".wav")
  '(out_path "./")
  '(out_ext ".pmv")


   ;;; MATLAB:  [B,A] = cheby1(6, 0.25, 2*50/22050, 'high')
  '(pre_filt1 ((0.98498330359240 -4.92478855324953 9.84944914386470
  -9.84944914386470 4.92478855324953 -0.98498330359240)
  (1.00000000000000 -4.95960988225764 9.83933219390989
  -9.76032482598845 4.84109270197799 -0.96049018727224)))

 ;;; MATLAB:   [B,A] = butter(2, 2*[50 250]/22050)
  '(vuv_filt ( ( 0.01195296847777 -0.04769554950591 0.05953219357852
 -0.00000000000002 -0.05953219357849 0.04769554950590
 -0.01195296847777) (1.00000000000000 -5.84361030166758
 14.22978800528706 -18.48249375023665 13.50486921945952
 -5.26335753257558 0.85480436135793)))

 '(diff_filt ((1 0 -1) (1)))

  '(lx_sign "up_is_closed_glottis")
  '(periods_per_Ewin 4.0)  ;; hamming win
  '(Eest_ppm 5.0) ;; number of energy estimates per pitch period
  '(guess_F0 120.0)
  '(F0_range_factor 1.5)
  '(Vbias 0.3)

  '(lpc_order 10) ;; for re-alignment of lx/speech
  '(shift_search_range 22)
  '(shift_guess 20)
  ))


(set! male22k_lpc_params  
 (list

  '(run_quietly 0) 
  '(dump_intermediate_files 0)
;  '(infile_list (directory-entries "."))
  '(infile_list ("mwm2_1.wav" "mwm2_10.wav" "mwm2_100.wav" "mwm2_1000.wav" "mwm2_210.wav" "mwm2_2100.wav"))

  '(pm_path "./")
  '(sp_path "./")
  '(pm_ext  ".pmv")
  '(sp_ext  ".wav")
  '(out_path "./")
  '(res_ext ".res")
  '(res_format "riff")
  '(lpc_format "lsf")
  '(lpc_ext ".lsf")

  '(lpc_order 16)
  '(lpc_anl_frame_len 3.0)  ;; half of this # of pitch periods to L and R
  '(pre_emphasis 0.96)

  '(ola_window_type "trapezoid") ;; for residual OLA
  '(T0_UV_thresh 0.0125)
  '(T0_UV_pm 0.01)

  '(res_max_normalize 1) ;; scale to MAXSHORT for storage
  ))



;;;
;;; do the computation
;;;
(OGIresLPC.pmark_analysis  male22k_pmark_params)
(OGIresLPC.lpc_analysis  male22k_lpc_params)


(quit)

