/****************************<--OGI-->*************************************/
/*                                                                        */
/*             Center for Spoken Language Understanding                   */
/*        Oregon Graduate Institute of Science & Technology               */
/*                         Portland, OR USA                               */
/*                        Copyright (c) 1999                              */
/*                                                                        */
/*      This module is not part of the CSTR/University of Edinburgh       */
/*               release of the Festival TTS system.                      */
/*                                                                        */
/*  In addition to any conditions disclaimers below, please see the file  */
/*  "license_ogi_tts.txt" distributed with this software for information  */
/*  on usage and redistribution, and for a DISCLAIMER OF ALL WARRANTIES.  */
/*                                                                        */
/****************************<--OGI-->*************************************/
#ifndef __OGI_SINGLETRACK_H__
#define __OGI_SINGLETRACK_H__

#include "EST.h"
#include "OGI_Track.h"


//
// Special case of a Track with only (t,val) pairs (one channel)
//
class OGI_SingleTrack : public OGI_Track {
  
private:
  bool setup_done;
public:
  OGI_SingleTrack(){
    set_num_channels(1);
  }

  void prepend(float t_in, float val_in){
    // prepend a single (t,val) pair
    int N=num_frames();
    EST_Track tmp;
    copy_sub_track(tmp);

    set_num_frames(N+1);
    t(0) = t_in;
    a(0,0) = val_in;
    
    for (int k=1; k<N+1; k++)
      copy_frame_in(k, tmp, k-1);  //@1.4
  }

  
  void append(float t_in, float val_in){
    int N=num_frames();

    // append a single (t,val) pair
    // **** later...
    //   - put in buffering to reduce # of resize()
    set_num_frames(N+1);
    t(N) = t_in;
    a(N,0) = val_in;
  }
  

  float linterp(float t_in){
    return interp(t_in, 0);
  }
    
};



#endif  

